/*
 
 ** AUTHOR: Marco Bellia
 ** LPL - Matematica
 ** Pisa 2019
 
 */
#include <stdio.h>
#include <stdlib.h>

typedef enum{false,true} bool;
 
//Strutture per rappresentare due tipi "con identica
//struttura di occupazione di memoria"
struct d{
    int Ad;
    char* Bd;
};
struct r{
    int Ar;
    char* Br;
};

//Tipi per abitanti, detenuti
typedef struct d * typeD;
typedef struct r * typeR;

bool showtypeD(typeD p){
    if (p==NULL) return false;
    printf("Ad:%d, Bd:%s\n", p->Ad, p->Bd);
    return true;
}

bool showtypeR(typeR p){
    if (p==NULL) return false;
    printf("Ar: %d, Br:%s\n ", p->Ar, p->Br);
    return true;
}
//
int main(void){
    typeD d1 = malloc(sizeof(typeR));
    d1->Ad = 17;
    d1->Bd = "1372";
    showtypeD(d1);
    typeR r1 = (typeR) d1;
    r1->Ar = -15;
    r1->Br = "mario";
    showtypeR(r1);
    showtypeD(d1);
    return 1;
}

/* Cosa dice la Semantica dei costrutti usati?
 
   Compila ed esegue come se fossero 2 variabili dello
   stesso tipo: la struttura di memoria e' condivisa.
 
 
 MarcoBelliasAir:CastEAllocazione marcob$ cc castEalloca1.c -o cEa1.exe
 MarcoBelliasAir:CastEAllocazione marcob$ ./cEA1.exe
 Ad:17, Bd:1372
 Ar: -15, Br:mario
 Ad:-15, Bd:mario
 MarcoBelliasAir:CastEAllocazione marcob$
 
 
 Se omettiamo il cast ...
 */
